#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * McSvcAccountInterfaceChannelRequests:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _McSvcAccountInterfaceChannelRequests McSvcAccountInterfaceChannelRequests;

/**
 * McSvcAccountInterfaceChannelRequestsClass:
 *
 * The class of McSvcAccountInterfaceChannelRequests.
 */
typedef struct _McSvcAccountInterfaceChannelRequestsClass McSvcAccountInterfaceChannelRequestsClass;

GType mc_svc_account_interface_channelrequests_get_type (void);
#define MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS \
  (mc_svc_account_interface_channelrequests_get_type ())
#define MC_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS, McSvcAccountInterfaceChannelRequests))
#define MC_IS_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS))
#define MC_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS, McSvcAccountInterfaceChannelRequestsClass))


typedef void (*mc_svc_account_interface_channelrequests_create_impl) (McSvcAccountInterfaceChannelRequests *self,
    GHashTable *in_Requested_Properties,
    guint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    DBusGMethodInvocation *context);
void mc_svc_account_interface_channelrequests_implement_create (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_create_impl impl);
/**
 * mc_svc_account_interface_channelrequests_return_from_create:
 * @context: The D-Bus method invocation context
 * @out_Request: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void mc_svc_account_interface_channelrequests_return_from_create (DBusGMethodInvocation *context,
    const gchar *out_Request);
static inline void
mc_svc_account_interface_channelrequests_return_from_create (DBusGMethodInvocation *context,
    const gchar *out_Request)
{
  dbus_g_method_return (context,
      out_Request);
}

typedef void (*mc_svc_account_interface_channelrequests_ensure_channel_impl) (McSvcAccountInterfaceChannelRequests *self,
    GHashTable *in_Requested_Properties,
    guint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    DBusGMethodInvocation *context);
void mc_svc_account_interface_channelrequests_implement_ensure_channel (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_ensure_channel_impl impl);
/**
 * mc_svc_account_interface_channelrequests_return_from_ensure_channel:
 * @context: The D-Bus method invocation context
 * @out_Request: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void mc_svc_account_interface_channelrequests_return_from_ensure_channel (DBusGMethodInvocation *context,
    const gchar *out_Request);
static inline void
mc_svc_account_interface_channelrequests_return_from_ensure_channel (DBusGMethodInvocation *context,
    const gchar *out_Request)
{
  dbus_g_method_return (context,
      out_Request);
}

typedef void (*mc_svc_account_interface_channelrequests_cancel_impl) (McSvcAccountInterfaceChannelRequests *self,
    const gchar *in_Request,
    DBusGMethodInvocation *context);
void mc_svc_account_interface_channelrequests_implement_cancel (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_cancel_impl impl);
/**
 * mc_svc_account_interface_channelrequests_return_from_cancel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void mc_svc_account_interface_channelrequests_return_from_cancel (DBusGMethodInvocation *context);
static inline void
mc_svc_account_interface_channelrequests_return_from_cancel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void mc_svc_account_interface_channelrequests_emit_failed (gpointer instance,
    const gchar *arg_Request,
    const gchar *arg_Error,
    const gchar *arg_Message);
void mc_svc_account_interface_channelrequests_emit_succeeded (gpointer instance,
    const gchar *arg_Request);


G_END_DECLS
