#include "_gen/svc-Account_Manager_Interface_Creation.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_manager_interface_creation_object_info;

struct _McSvcAccountManagerInterfaceCreationClass {
    GTypeInterface parent_class;
    mc_svc_account_manager_interface_creation_create_account_impl create_account;
};

static void mc_svc_account_manager_interface_creation_base_init (gpointer klass);

GType
mc_svc_account_manager_interface_creation_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountManagerInterfaceCreationClass),
        mc_svc_account_manager_interface_creation_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountManagerInterfaceCreation", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_manager_interface_creation_create_account_impl:
 * @self: The object implementing this interface
 * @in_Connection_Manager: const gchar * (FIXME, generate documentation)
 * @in_Protocol: const gchar * (FIXME, generate documentation)
 * @in_Display_Name: const gchar * (FIXME, generate documentation)
 * @in_Parameters: GHashTable * (FIXME, generate documentation)
 * @in_Properties: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * CreateAccount on interface org.freedesktop.Telepathy.AccountManager.Interface.Creation.DRAFT.
 */
static void
mc_svc_account_manager_interface_creation_create_account (McSvcAccountManagerInterfaceCreation *self,
    const gchar *in_Connection_Manager,
    const gchar *in_Protocol,
    const gchar *in_Display_Name,
    GHashTable *in_Parameters,
    GHashTable *in_Properties,
    DBusGMethodInvocation *context)
{
  mc_svc_account_manager_interface_creation_create_account_impl impl = (MC_SVC_ACCOUNT_MANAGER_INTERFACE_CREATION_GET_CLASS (self)->create_account);

  if (impl != NULL)
    {
      (impl) (self,
        in_Connection_Manager,
        in_Protocol,
        in_Display_Name,
        in_Parameters,
        in_Properties,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_manager_interface_creation_implement_create_account:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CreateAccount D-Bus method
 *
 * Register an implementation for the CreateAccount method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_manager_interface_creation_implement_create_account (McSvcAccountManagerInterfaceCreationClass *klass, mc_svc_account_manager_interface_creation_create_account_impl impl)
{
  klass->create_account = impl;
}

static inline void
mc_svc_account_manager_interface_creation_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (mc_svc_account_manager_interface_creation_get_type (),
      &_mc_svc_account_manager_interface_creation_object_info);

}
static void
mc_svc_account_manager_interface_creation_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_manager_interface_creation_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_manager_interface_creation_methods[] = {
  { (GCallback) mc_svc_account_manager_interface_creation_create_account, _mc_ext_marshal_VOID__STRING_STRING_STRING_BOXED_BOXED_POINTER, 0 },
};

static const DBusGObjectInfo _mc_svc_account_manager_interface_creation_object_info = {
  0,
  _mc_svc_account_manager_interface_creation_methods,
  1,
"org.freedesktop.Telepathy.AccountManager.Interface.Creation.DRAFT\0CreateAccount\0A\0Connection_Manager\0I\0s\0Protocol\0I\0s\0Display_Name\0I\0s\0Parameters\0I\0a{sv}\0Properties\0I\0a{sv}\0Account\0O\0F\0N\0o\0\0\0",
"\0\0",
"\0\0",
};


