#include "_gen/svc-Account_Manager_Interface_Query.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_manager_interface_query_object_info;

struct _McSvcAccountManagerInterfaceQueryClass {
    GTypeInterface parent_class;
    mc_svc_account_manager_interface_query_find_accounts_impl find_accounts;
};

static void mc_svc_account_manager_interface_query_base_init (gpointer klass);

GType
mc_svc_account_manager_interface_query_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountManagerInterfaceQueryClass),
        mc_svc_account_manager_interface_query_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountManagerInterfaceQuery", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_manager_interface_query_find_accounts_impl:
 * @self: The object implementing this interface
 * @in_params: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * FindAccounts on interface com.nokia.AccountManager.Interface.Query.
 */
static void
mc_svc_account_manager_interface_query_find_accounts (McSvcAccountManagerInterfaceQuery *self,
    GHashTable *in_params,
    DBusGMethodInvocation *context)
{
  mc_svc_account_manager_interface_query_find_accounts_impl impl = (MC_SVC_ACCOUNT_MANAGER_INTERFACE_QUERY_GET_CLASS (self)->find_accounts);

  if (impl != NULL)
    {
      (impl) (self,
        in_params,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_manager_interface_query_implement_find_accounts:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the FindAccounts D-Bus method
 *
 * Register an implementation for the FindAccounts method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_manager_interface_query_implement_find_accounts (McSvcAccountManagerInterfaceQueryClass *klass, mc_svc_account_manager_interface_query_find_accounts_impl impl)
{
  klass->find_accounts = impl;
}

static inline void
mc_svc_account_manager_interface_query_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "as", 0, NULL, NULL }, /* Keywords */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (mc_svc_account_manager_interface_query_get_type (),
      &_mc_svc_account_manager_interface_query_object_info);

  interface.dbus_interface = g_quark_from_static_string ("com.nokia.AccountManager.Interface.Query");
  properties[0].name = g_quark_from_static_string ("Keywords");
  properties[0].type = G_TYPE_STRV;
  tp_svc_interface_set_dbus_properties_info (MC_TYPE_SVC_ACCOUNT_MANAGER_INTERFACE_QUERY, &interface);

}
static void
mc_svc_account_manager_interface_query_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_manager_interface_query_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_manager_interface_query_methods[] = {
  { (GCallback) mc_svc_account_manager_interface_query_find_accounts, _mc_ext_marshal_VOID__BOXED_POINTER, 0 },
};

static const DBusGObjectInfo _mc_svc_account_manager_interface_query_object_info = {
  0,
  _mc_svc_account_manager_interface_query_methods,
  1,
"com.nokia.AccountManager.Interface.Query\0FindAccounts\0A\0params\0I\0a{sv}\0accounts\0O\0F\0N\0ao\0\0\0",
"\0\0",
"\0\0",
};


